#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>
#include <gl/GLU.h>
#include <QDebug>
#include <QWheelEvent>

class MyGLWidget : public QGLWidget
{
    Q_OBJECT //from HelloGL Example

   public:
       MyGLWidget(QWidget *parent = 0);
       ~MyGLWidget();

       //From HelloGL example.
       QSize minimumSizeHint() const;//do I need this?
       QSize sizeHint() const;//do I need this?

protected:
       //4.1 Core Functionality
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void wheelEvent(QWheelEvent *event);

private:
    int tesselation;
    double cameraZoom;
    QPoint clickStartPosition;
    bool rightButtonPressed;
    double translationX, translationY;


public slots:
    //4.1.1 slots for shading modes
    void shadeWireframeSlot();
    void shadeFlatSlot();
    void shadeGouraudSlot();
    void shadePhongSlot();
    void setTessellation(int t);
};

#endif // GLWIDGET_H
